function [u,err]=jac(A,f,u,niter,omega)

if nargout>=2
  uexact=A\f;
end

n=sqrt(length(f));
D=diag(diag(A));
LU=-(tril(A,-1)+triu(A,1));

err=zeros(1,niter);
for ii=1:niter
  u=omega*(D\(LU*u+f))+(1-omega)*u;
  if nargout>=2
    err(ii)=norm(u-uexact)/sqrt(n);
  end
end
