function [u,err]=mg(gridsize,B,niter,omega,backslash)

nu1=2;
nu2=2;
nu3=4;

n=gridsize-1;
uh=zeros(n^2,1);
[Ah,fh]=assemble(gridsize,B);
A2h=assemble(gridsize/2,B);
if nargout>=2
  uexact=Ah\fh;
end
for ii=1:niter
  uh=jac(Ah,fh,uh,nu1,omega);
  rh=fh-Ah*uh;
  r2h=restrict(rh);
  if backslash
    e2h=A2h\r2h;
  else
    e2h=jac(A2h,r2h,zeros(size(r2h)),nu3,1.0);
  end
  eh=prolongate(e2h);
  uh=uh+eh;
  uh=jac(Ah,fh,uh,nu2,omega);
  if nargout>=2
    err(ii)=norm(uh-uexact)/sqrt(n);
  end
end
u=uh;
