function [u,err]=mgv(gridsize,B,niter,omega,refinements)

nu1=2;
nu2=2;

finegrid=gridsize/2^refinements;

n=gridsize-1;
uh=zeros(n^2,1);
[Ah,fh]=assemble(gridsize,B);
if nargout>=2
  uexact=Ah\fh;
end
for ii=1:niter
  uh=VGh(uh,fh,B,finegrid,nu1,nu2,omega);
  if nargout>=2
    err(ii)=norm(uh-uexact)/sqrt(n);
  end
end
u=uh;

function uh=VGh(uh,fh,B,finegrid,nu1,nu2,omega)

n=sqrt(length(uh))+1;
Ah=assemble(n,B);
uh=jac(Ah,fh,uh,nu1,omega);
if n>finegrid
  r2h=restrict(fh-Ah*uh);
  e2h=VGh(zeros(size(r2h)),r2h,B,finegrid,nu1,nu2,omega);
  uh=uh+prolongate(e2h);
end
uh=jac(Ah,fh,uh,nu2,omega);
